#ifndef OPENSIM_OSIMCOMMON_H_
#define OPENSIM_OSIMCOMMON_H_
/* -------------------------------------------------------------------------- *
 *                           OpenSim:  osimCommon.h                           *
 * -------------------------------------------------------------------------- *
 * The OpenSim API is a toolkit for musculoskeletal modeling and simulation.  *
 * See http://opensim.stanford.edu and the NOTICE file for more information.  *
 * OpenSim is developed at Stanford University and supported by the US        *
 * National Institutes of Health (U54 GM072970, R24 HD065690) and by DARPA    *
 * through the Warrior Web program.                                           *
 *                                                                            *
 * Copyright (c) 2005-2017 Stanford University and the Authors                *
 * Author(s): Ayman Habib                                                     *
 *                                                                            *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may    *
 * not use this file except in compliance with the License. You may obtain a  *
 * copy of the License at http://www.apache.org/licenses/LICENSE-2.0.         *
 *                                                                            *
 * Unless required by applicable law or agreed to in writing, software        *
 * distributed under the License is distributed on an "AS IS" BASIS,          *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *
 * See the License for the specific language governing permissions and        *
 * limitations under the License.                                             *
 * -------------------------------------------------------------------------- */

#include "About.h"
#include "Adapters.h"
#include "CommonUtilities.h"
#include "Constant.h"
#include "DataTable.h"
#include "FunctionSet.h"
#include "GCVSpline.h"
#include "GCVSplineSet.h"
#include "IO.h"
#include "LinearFunction.h"
#include "LoadOpenSimLibrary.h"
#include "Logger.h"
#include "ModelDisplayHints.h"
#include "MultiplierFunction.h"
#include "MultivariatePolynomialFunction.h"
#include "Object.h"
#include "ObjectGroup.h"
#include "PiecewiseConstantFunction.h"
#include "PiecewiseLinearFunction.h"
#include "PolynomialFunction.h"
#include "RegisterTypes_osimCommon.h" // to expose RegisterTypes_osimCommon
#include "Reporter.h"
#include "Scale.h"
#include "ScaleSet.h"
#include "SignalGenerator.h"
#include "SimmSpline.h"
#include "Sine.h"
#include "SmoothSegmentedFunctionFactory.h"
#include "StepFunction.h"
#include "Stopwatch.h"
#include "StorageInterface.h"
#include "TableSource.h"
#include "TableUtilities.h"
#include "TimeSeriesTable.h"

#endif // OPENSIM_OSIMCOMMON_H_
